<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink"
    xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Chaitin!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>
    <section>
        <title>Iteratív és rekurzív faktoriális Lisp-ben</title>
        <para> Megoldás videó: <link xlink:href="https://youtu.be/z6NJE2a1zIA"
                >https://youtu.be/z6NJE2a1zIA</link>
        </para>
        <para> A GIMP a GNU Image Manipulation Program angol kifejezés rövidítése, egy képszerkesztő
            program, ami számtalan lehetőséget bizosít számunkra, egyértelműen nem a leggagyibb
            rajzprogram. Az alapvető funkciók mellett (amiket egy Paint is tud) képes rétegekkel és
            csatornákkal foglalkozni, képeket méretezni, kápátalakításokat végezni, mint például a
            forgatás vagy a torzítás. 1995-ben Spencer Kimball és Peter Mattis volt az, akik
            megalkották ezt az alkalmazást, azóta inkább csak önkéntes szoftverfejlesztők dolgoznak
            rajta, fejlesztgetik. A GIMP különlegessége, hogy külső programokból lehet meghívni
            benne funkciókat vagy be lehet építeni különböző pluginokat. </para>
        <para>A feladatunk, hogy Lisp nyelven ebben a GNU képszerkesztő programban kipróbáljuk az
            iteratív és rekturzív faktoriálist. Ehhez elsősorban kicsit meg kell ismerkednünk a Lisp
            nyelvvel. Ez a mesterséges intelligencia egy alapvető programozási nyelve már a
            kezdetektől óta. Fontos, meghatározó szerepet játszik a kutatásban és az eredmények
            gyakorlati alkalmazásában is. A Lisp a List Processing Language rövidítése, ami magyarul
            listafeldolgozó nyelvet jelent. Azért hozták létre, hogy szimbolumokból álló
            kifejezésekkel végzett műveletekre alkalmat nyelvet teremthessenek. Mivel új
            elgondolások alapján tervezték meg, így ezen tulajdonságok tekintetében a Lisp a
            funkcionális nyelveknek lett az első és a legfontosabb képviselője. </para>
        <para>A Lisp egy kifejezésorientált nyelv, ez azt jelenti, hogy nincsen kontraszt
            parancsok és kifejezések között, mindent kifejezések formájában jegyzünk le.
            Azaz leírunk egy kifejezést, ezt kiértékeli az értelmező és megkapunk
            egy eredményt, amit aztán egy újabb kifejezésbe illeszthetünk be akár. A Lisp alap
            építőelemei az atomok, ezeknél kisebb elemek nincsenek a nyelvben, de akár csak a
            valóságban is az atomok, ezek sem "oszthatatlanok", szerkezettel rendelkeznek. Két féle
            atom létezik, a szimbólikus atom, ahol szimbólumok (betűk és számjegyek
            karaktersorozata) vannak, illetve numerikus atom, ahol pedig számokról (0-9, pozitív,
            negatív) beszélhetünk. Ha egy atomban szóköz jelenik meg, akkor az az atom végét
            jelenti, tehát nem lehet egy atom közepén, csakis a végén. Ugyancsak lezár egy atomot a
            sorvég is. Az atomokból épülnek fel a listák, illetve léteznek függvények is. </para>
        <para>A feladatunk megoldásához pontosan egy függvényt kell használunk, ehhez ismernünk kell
            pár alapvető műveletet a nyelvben, így például két számnak az összegét vagy egy számnak
            a négyzetre emelését. </para>
        <para>A faktoriális függvényünk legyen ez: <code>(define (fakt n(* n n))</code>. Itt
            elneveztük a függvényt <parameter>fakt</parameter>-nak, és megmondjuk, hogy az n
            faktoriális (n!) azt jelentse, hogy összeszorozza a számokat n-ig. Az előzőekben
            használt nyelvek esetén, mint például C vagy Java, egy ciklust hoznánk létre, hogy
            faktoriálist számoljunk, a Lisp nyelv viszont máshogy működik. </para>
        <para>A függvényünket tovább írjuk, így kapjuk az <code>define(fakt n) (if &lt; n 1)</code>,
            tehát beletettünk egy vizsgálatot az if-fel. Ez azt nézi, hogy az n kisebb-e már az
            1-nél. Ebbe viszont még bele kell raknunk a faktoriálist, így nem megfelelő erre a
            kódunk. Ennek megfelelően tovább kell írnunk: <code>(define (fakt n) (if (&lt; n
                1)1()))</code>. Itt, ha a feltétlen igaz, akkor az értéke az első kifejezés, vagyis
            jelen esetben az 1. Ha viszont hamis, akkor a második értéket kapja meg vagyis a ()
            jelek. Meghatároztuk azt a feltételt, amikor az n kisebb, mint egy, viszont valamit
            írnunk kell azokra a helyzetekre, amikor az n értéke nagyobb: <code>(define (fakt n) (if
                (&lt; n 1) 1 (*n (fakt (-n 1)))))</code>. Ennek érdekében át kell írnunk a második
            értéket, helyette szorzást írunk, megszorozzuk a faktoriálist úgy, hogy eggyel
            kevesebbet írunk. Ennek futtatásához a <code>(fakt n)</code> formátumot használjuk, ahol
            az <parameter>n</parameter> helyére egy tetszőleges számot használhatunk, például a
            3-ast. </para>
        <para>
            <figure>
                <title/>
                <mediaobject>
                    <imageobject>
                        <imagedata fileref="8csokor/lisp.png" scale="70"/>
                    </imageobject>
                    <textobject>
                        <phrase/>
                    </textobject>
                </mediaobject>
            </figure>
        </para>
    </section>
    <section>
        <title>Gimp Scheme Script-fu: króm effekt</title>
        <para><emphasis> Írj olyan script-fu kiterjesztést a GIMP programhoz, amely megvalósítja a
                króm effektet egy bemenő szövegre! </emphasis></para>
        <para> Megoldás videó: <link xlink:href="https://youtu.be/OKdAkI_c7Sc"
                >https://youtu.be/OKdAkI_c7Sc</link>
        </para>
        <para> Megoldás forrása: <link
                xlink:href="https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/GIMP_Lisp/Chrome"
                >https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/GIMP_Lisp/Chrome</link>
        </para>
        <para>A GIMP programba telepíthetőek úgynevezett Script-Fuk, amik másabbak, és talán még
            érdekesebbek is, mint a plug-inek. Ezek platformfüggetlen GIMP alkalmazások, azaz
            bármilyen rendszerben használhatóak (ugyanis a plug-inek vagy csak Linuxon, vagy csak
            Windows-on alkalmazhatóak), és egyszerűen tudunk mindenféle hatásokat, árnyékokat
            alkotni, kereteket, logókat létrehozni. Ezek a scriptek .scm kiterjesztésűek és a
                <code>Kép -> Script-Fu</code> mappából tudjuk elindítani őket. A telepítéssel
            körülbelül 100 scriptet kapunk meg, ez a szám persze viszont bővíthető az interneten
            letöltött scriptekkel, de akár mi magunk is írhatunk sajátokat. A feladatunk pont az,
            hogy egy olyan scriptet írjunk meg, ami megvalósítja a króm effektet egy bemenő
            szövegre, ebben segít Bátfai Norbert forráskódja és videója. </para>
        <para>
            <programlisting><![CDATA[(define (color-curve)
    (let* (
        (tomb (cons-array 8 'byte))
    )
        (aset tomb 0 0)
        (aset tomb 1 0)
        (aset tomb 2 50)
        (aset tomb 3 190)
        (aset tomb 4 110)
        (aset tomb 5 20)
        (aset tomb 6 200)
        (aset tomb 7 190)
    tomb)    
)

;(color-curve)

(define (elem x lista)

    (if (= x 1) (car lista) (elem (- x 1) ( cdr lista ) ) )
)

(define (text-wh text font fontsize)
(let*
    (
        (text-width 1)
        (text-height 1)
    )
 
    (set! text-width (car (gimp-text-get-extents-fontname text fontsize PIXELS font)))    
    (set! text-height (elem 2  (gimp-text-get-extents-fontname text fontsize PIXELS font)))    
    
    (list text-width text-height)
    )
)

;(text-width "alma" "Sans" 100)

(define (script-fu-bhax-chrome text font fontsize width height color gradient)
(let*
    (
        (image (car (gimp-image-new width height RGB)))
        (layer (car (gimp-layer-new image width height RGB-IMAGE "bg" 100 LAYER-MODE-NORMAL-LEGACY)))
        (textfs)
        (text-width (car (text-wh text font fontsize)))
        (text-height (elem 2 (text-wh text font fontsize)))
        (layer2)        
    )
    
    ;step 1
    (gimp-image-insert-layer image layer 0 0)
    (gimp-context-set-foreground '(0 0 0))
    (gimp-drawable-fill layer  FILL-FOREGROUND )
    (gimp-context-set-foreground '(255 255 255))
   
    (set! textfs (car (gimp-text-layer-new image text font fontsize PIXELS)))
    (gimp-image-insert-layer image textfs 0 0)   
    (gimp-layer-set-offsets textfs (- (/ width 2) (/ text-width 2)) (- (/ height 2) (/ text-height 2)))
   
    (set! layer (car(gimp-image-merge-down image textfs CLIP-TO-BOTTOM-LAYER)))
   
    ;step 2   
    (plug-in-gauss-iir RUN-INTERACTIVE image layer 15 TRUE TRUE)
   
    ;step 3
    (gimp-drawable-levels layer HISTOGRAM-VALUE .11 .42 TRUE 1 0 1 TRUE)
   
    ;step 4   
    (plug-in-gauss-iir RUN-INTERACTIVE image layer 2 TRUE TRUE)

    ;step 5    
    (gimp-image-select-color image CHANNEL-OP-REPLACE layer '(0 0 0))
    (gimp-selection-invert image)

    ;step 6        
    (set! layer2 (car (gimp-layer-new image width height RGB-IMAGE "2" 100 LAYER-MODE-NORMAL-LEGACY)))
    (gimp-image-insert-layer image layer2 0 0)

    ;step 7        
	(gimp-context-set-gradient gradient) 
	(gimp-edit-blend layer2 BLEND-CUSTOM LAYER-MODE-NORMAL-LEGACY GRADIENT-LINEAR 100 0 REPEAT-NONE 
        FALSE TRUE 5 .1 TRUE width (/ height 3) width  (- height (/ height 3)))
    
    ;step 8        
    (plug-in-bump-map RUN-NONINTERACTIVE image layer2 layer 120 25 7 5 5 0 0 TRUE FALSE 2)
   
    ;step 9       
    (gimp-curves-spline layer2 HISTOGRAM-VALUE 8 (color-curve))
      
    (gimp-display-new image)
    (gimp-image-clean-all image)
    )
)

;(script-fu-bhax-chrome "Bátf41 Haxor" "Sans" 120 1000 1000 '(255 0 0) "Crown molding")

(script-fu-register "script-fu-bhax-chrome"
    "Chrome3"
    "Creates a chrome effect on a given text."
    "Norbert Bátfai"
    "Copyright 2019, Norbert Bátfai"
    "January 19, 2019"
    ""
    SF-STRING       "Text"      "Bátf41 Haxor"
    SF-FONT         "Font"      "Sans"
    SF-ADJUSTMENT   "Font size" '(100 1 1000 1 10 0 1)
    SF-VALUE        "Width"     "1000"
    SF-VALUE        "Height"    "1000"
    SF-COLOR        "Color"     '(255 0 0)
    SF-GRADIENT     "Gradient"  "Crown molding"    
)
(script-fu-menu-register "script-fu-bhax-chrome" 
    "<Image>/File/Create/BHAX"
)]]></programlisting>
        </para>
        <para>
            <programlisting><![CDATA[(define (script-fu-bhax-chrome text font fontsize width height color gradient)
(let*
    (
        (image (car (gimp-image-new width height RGB)))
        (layer (car (gimp-layer-new image width height RGB-IMAGE "bg" 100 LAYER-MODE-NORMAL-LEGACY)))
        (textfs)
        (text-width (car (text-wh text font fontsize)))
        (text-height (elem 2 (text-wh text font fontsize)))
        (layer2)        
    )]]></programlisting>
        </para>
        <para>A <code>(image (car (gimp-image-new width height 0)))</code> sor meghívja a
                <function>gimp-image-new</function> függvényt, ami létrehoz egy új képet a megadott
            szélességgel, magassággal és típussal. A <function>car</function> függvény visszaad egy
            listát (mint minden GIMP függvény), az egy elemű listát, vagyis az elkészült image-t,
            amit berak a mi <varname>image</varname> nevű változónkba. És ugyanezt megcsináljuk a
                <varname>layer</varname>-rel is. </para>
        <para>
            <programlisting>    ;step 1
    (gimp-image-insert-layer image layer 0 0)
    (gimp-context-set-foreground '(0 0 0))
    (gimp-drawable-fill layer  FILL-FOREGROUND )
    (gimp-context-set-foreground '(255 255 255))
   
    (set! textfs (car (gimp-text-layer-new image text font fontsize PIXELS)))
    (gimp-image-insert-layer image textfs 0 0)   
    (gimp-layer-set-offsets textfs (- (/ width 2) (/ text-width 2)) (- (/ height 2) (/ text-height 2)))
   
    (set! layer (car(gimp-image-merge-down image textfs CLIP-TO-BOTTOM-LAYER)))</programlisting>
        </para>
        <para>A feladat első lépésében először a <varname>gimp-image-insert layer</varname>-t
            hozzáadjuk a képhez, és beállítjuk a színeket, elsőnek a hátteret, ehhez fekete színt
            választottunk, ezt a vödör eszközzel valósítjuk be, aztán a színt fehérre állítjuk be,
            hiszen a szövegünknek már ezt az alapot akarjuk. Kiírjuk a megadott betűtípussal,
            betűmérettel a szövegünket, illetve középre igazítottuk ezt a
                <code>gimp-layer-set-offsets</code> segítségével. Az utolsó sorral állítjuk be azt,
            hogy ez az egész egy réteg legyen, ne kettő, ahogyan egyébként lenne a háttér és a
            szöveg megalkotása során. </para>
        <para>
            <programlisting><![CDATA[    ;step 2   
    (plug-in-gauss-iir RUN-INTERACTIVE image layer 15 TRUE TRUE)
   
    ;step 3
    (gimp-drawable-levels layer HISTOGRAM-VALUE .11 .42 TRUE 1 0 1 TRUE)
   
    ;step 4   
    (plug-in-gauss-iir RUN-INTERACTIVE image layer 2 TRUE TRUE)

    ;step 5    
    (gimp-image-select-color image CHANNEL-OP-REPLACE layer '(0 0 0))
    (gimp-selection-invert image)]]></programlisting>
        </para>
        <para>A második lépésben be kell állítanunk a Gauss-elmosódást, ezt 15-ös értékre állítjuk
            be. Ennek a funkciója az, hogy a szöveg sarkai kerekítettek, élei simák legyenek.
            Változtatunk a színek szintjén, majd újabb elmosódást vetünk be, most viszont lágyabban,
            ennek a kettes értéket adtuk meg. Az ötödik lépés már komolyabb, kiválasztjuk a kép
            fekete szín részét, vagyis a hátteret, a fehér szöveget kihagyva, majd invertáljuk ezt. </para>
        <para>
            <programlisting>    ;step 6        
    (set! layer2 (car (gimp-layer-new image width height RGB-IMAGE "2" 100 LAYER-MODE-NORMAL-LEGACY)))
    (gimp-image-insert-layer image layer2 0 0)

    ;step 7        
	(gimp-context-set-gradient gradient) 
	(gimp-edit-blend layer2 BLEND-CUSTOM LAYER-MODE-NORMAL-LEGACY GRADIENT-LINEAR 100 0 REPEAT-NONE 
        FALSE TRUE 5 .1 TRUE width (/ height 3) width  (- height (/ height 3)))
    
    ;step 8        
    (plug-in-bump-map RUN-NONINTERACTIVE image layer2 layer 120 25 7 5 5 0 0 TRUE FALSE 2)
   
    ;step 9       
    (gimp-curves-spline layer2 HISTOGRAM-VALUE 8 (color-curve))
      
    (gimp-display-new image)
    (gimp-image-clean-all image)
    )</programlisting>
        </para>
        <para>A hatodik lépésben létrehozunk egy második réteget transzparensnek, ennek 100%
            átlátszóságot állítunk be, vagyis átlátszó hátteret, kikapcsoljuk az első réteget, aztán
            kijelöljük a második réteget. a hetedik lépésben történik a feltöltés, a transzparens,
            vagyis a második réteget kell beszíneznünk valamilyen gradiensre, azaz két színre,
            amiből amibe vált a betűszín, magyarul: színátmenetet csinál. A nyolcadik lépés során a
            2. réteget leképezzük az első rétegre a térképen. A GIMP bump map párbeszédablak
            alapértelmezetten használni akarja a térkép aktív rétegét, ezért fontos, hogy az 1. nem
            átlátszó réteg legyen beállítva használhatónak. Gyakorlatilag mélységet állítunk be a
            szövegnek. A kilencedik lépésben a hisztogram értéket állítjuk be, ezt nyolcasra
            állítjuk be, ezzel érünk el fémes hatást a szövegnek. </para>
        <para>
            <programlisting>(script-fu-register "script-fu-bhax-chrome"
    "Chrome3"
    "Creates a chrome effect on a given text."
    "Norbert Bátfai"
    "Copyright 2019, Norbert Bátfai"
    "January 19, 2019"
    ""
    SF-STRING       "Text"      "Bátf41 Haxor"
    SF-FONT         "Font"      "Sans"
    SF-ADJUSTMENT   "Font size" '(100 1 1000 1 10 0 1)
    SF-VALUE        "Width"     "1000"
    SF-VALUE        "Height"    "1000"
    SF-COLOR        "Color"     '(255 0 0)
    SF-GRADIENT     "Gradient"  "Crown molding"    
)
(script-fu-menu-register "script-fu-bhax-chrome" 
    "&lt;Image>/File/Create/BHAX"
)</programlisting>
        </para>
        <para>A program regisztrációjáért ez a rész felelős, ez abban segít nekünk, hogy könnyű, pár
            kisebb lépéssel beállíthassuk a mi kis képünket. Megadhatjuk a szövegünket, amire
            szeretnénk alkalmazni a króm effektet. Kiválaszthatjuk a betűtípust, a méretet, a
            szélességet és magasságot, a színt és a gradienst is. Tehát egy ilyen scriptnek a
            megírásával meg tudjuk könnyíteni a dolgunkat, hiszen nem nekünk kell megcsinálni az
            egyes lépéseket, hanem pár alapvető adat megadásával a program meg le is generálja
            számunkra a megfelelő hatást. </para>
        <para>
            <figure>
                <title/>
                <mediaobject>
                    <imageobject>
                        <imagedata fileref="8csokor/chrome.png" scale="35"/>
                    </imageobject>
                    <textobject>
                        <phrase/>
                    </textobject>
                </mediaobject>
            </figure>
        </para>
    </section>
    <section>
        <title>Gimp Scheme Script-fu: név mandala</title>
        <para><emphasis> Írj olyan script-fu kiterjesztést a GIMP programhoz, amely név-mandalát
                készít a bemenő szövegből! </emphasis></para>
        <para> Megoldás videó: <link
                xlink:href="https://bhaxor.blog.hu/2019/01/10/a_gimp_lisp_hackelese_a_scheme_programozasi_nyelv"
                >https://bhaxor.blog.hu/2019/01/10/a_gimp_lisp_hackelese_a_scheme_programozasi_nyelv</link>
        </para>
        <para> Megoldás forrása: <link
                xlink:href="https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/GIMP_Lisp/Mandala"
                >https://gitlab.com/nbatfai/bhax/tree/master/attention_raising/GIMP_Lisp/Mandala</link>
        </para>
        <para> A mandala szó ősi indiai nyelvből ered, kört, ívet jelent. Az első mandalák
            körülbelül 7-8 ezer évvel ezelőtt keletkeztek mezopotámiai mintákon. De ugyanúgy
            megtalálhatóak a régi amerikai népek, a maják, inkák, illetve az arabok és a buddhisták
            művészetében is. Különlegesség, hogy a mandalák formái és színei a természetben is
            észrevehetőek, leggyakrabban élőlények mintájában. </para>
        <para>A mandalák nem feltétlenül kör formájában jelennek meg, viszont fontos, hogy a külső
            és a belső világmindenséget ki kell fejezniük. Ez azért van, mert a hinduk szerint a
            szabályosan ismétlődő formák hatással vannak az emberre, képes kiegyensúlyozott
            harmóniát kialakítani az agyféltekék között, így befolyásolva az energiaszintet. A
            mandalák különféle színekkel rendelkeznek, amik bizonyítottan hatással vannak az ember
            szervezetére, hiszen gyakorlatilag úgy viselkednek, mintha fényt sugároznának, azokról
            epdig köztudott, hogy egyfajta elektromágneses hullámként viselkednek, amire a biológiai
            szervezet igen érzékeny. </para>
        <para>A névmandalák lényegében ugyanolyanok, mint a mandalák, csupán a megadott névből hozza
            létre a mandalát, természetesen folyamatosan elforgatva, így fog felépülni. Feladatunk a
            saját nevünkből névmandalát készíteni, természetesen egy script megírásával, hogy ezt
            bárki meg tudja valósítani pusztán pár adat megadásával. Íme a forráskód: </para>
        <para>
            <programlisting><![CDATA[(define (elem x lista)

    (if (= x 1) (car lista) (elem (- x 1) ( cdr lista ) ) )
)

(define (text-width text font fontsize)
(let*
    (
        (text-width 1)
    )
    (set! text-width (car (gimp-text-get-extents-fontname text fontsize PIXELS font)))

    text-width
    )
)

(define (text-wh text font fontsize)
(let*
    (
        (text-width 1)
        (text-height 1)
    )

    (set! text-width (car (gimp-text-get-extents-fontname text fontsize PIXELS font)))
        ;;;
    (set! text-height (elem 2  (gimp-text-get-extents-fontname text fontsize PIXELS font)))
        ;;;
    (list text-width text-height)
    )
)

;(text-width "alma" "Sans" 100)

(define (script-fu-bhax-mandala text text2 font fontsize width height color gradient)
(let*
    (
        (image (car (gimp-image-new width height 0)))
        (layer (car (gimp-layer-new image width height RGB-IMAGE "bg" 100 LAYER-MODE-NORMAL-LEGACY)))
        (textfs)
        (text-layer)
        (text-width (text-width text font fontsize))
        ;;;
        (text2-width (car (text-wh text2 font fontsize)))
        (text2-height (elem 2 (text-wh text2 font fontsize)))
        ;;;
        (textfs-width)
        (textfs-height)
        (gradient-layer)
    )

    (gimp-image-insert-layer image layer 0 0)

    (gimp-context-set-foreground '(0 255 0))
    (gimp-drawable-fill layer FILL-FOREGROUND)
    (gimp-image-undo-disable image) 

    (gimp-context-set-foreground color)

    (set! textfs (car (gimp-text-layer-new image text font fontsize PIXELS)))
    (gimp-image-insert-layer image textfs 0 -1)
    (gimp-layer-set-offsets textfs (- (/ width 2) (/ text-width 2))  (/ height 2))
    (gimp-layer-resize-to-image-size textfs)

    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate-simple text-layer ROTATE-180 TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))

    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 2) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))

    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 4) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))
    
    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 6) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))    
    
    (plug-in-autocrop-layer RUN-NONINTERACTIVE image textfs)
    (set! textfs-width (+ (car(gimp-drawable-width textfs)) 100))
    (set! textfs-height (+ (car(gimp-drawable-height textfs)) 100))
        
	(gimp-layer-resize-to-image-size textfs)
    
    (gimp-image-select-ellipse image CHANNEL-OP-REPLACE (- (- (/ width 2) (/ textfs-width 2)) 18) 
        (- (- (/ height 2) (/ textfs-height 2)) 18) (+ textfs-width 36) (+ textfs-height 36))
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)
        
    (gimp-context-set-brush-size 22)
    (gimp-edit-stroke textfs)
    
    (set! textfs-width (- textfs-width 70))
    (set! textfs-height (- textfs-height 70))
    
    (gimp-image-select-ellipse image CHANNEL-OP-REPLACE (- (- (/ width 2) (/ textfs-width 2)) 18) 
        (- (- (/ height 2) (/ textfs-height 2)) 18) (+ textfs-width 36) (+ textfs-height 36))
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)
        
    (gimp-context-set-brush-size 8)
    (gimp-edit-stroke textfs)
        
    (set! gradient-layer (car (gimp-layer-new image width height RGB-IMAGE "gradient" 100 LAYER-MODE-NORMAL-LEGACY)))
    
    (gimp-image-insert-layer image gradient-layer 0 -1)
	(gimp-image-select-item image CHANNEL-OP-REPLACE textfs)
	(gimp-context-set-gradient gradient) 
	(gimp-edit-blend gradient-layer BLEND-CUSTOM LAYER-MODE-NORMAL-LEGACY GRADIENT-RADIAL 100 0 
	REPEAT-TRIANGULAR FALSE TRUE 5 .1 TRUE (/ width 2) (/ height 2) (+ (+ (/ width 2) (/ textfs-width 2)) 8) (/ height 2))
	
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)

    (set! textfs (car (gimp-text-layer-new image text2 font fontsize PIXELS)))
    (gimp-image-insert-layer image textfs 0 -1)
    (gimp-message (number->string text2-height))
    (gimp-layer-set-offsets textfs (- (/ width 2) (/ text2-width 2)) (- (/ height 2) (/ text2-height 2)))
		
    ;(gimp-selection-none image)
    ;(gimp-image-flatten image)
    
    (gimp-display-new image)
    (gimp-image-clean-all image)
    )
)

;(script-fu-bhax-mandala "Bátfai Norbert" "BHAX" "Ruge Boogie" 120 1920 1080 '(255 0 0) "Shadows 3")

(script-fu-register "script-fu-bhax-mandala"
    "Mandala9"
    "Creates a mandala from a text box."
    "Norbert Bátfai"
    "Copyright 2019, Norbert Bátfai"
    "January 9, 2019"
    ""
    SF-STRING       "Text"      "Bátf41 Haxor"
    SF-STRING       "Text2"     "BHAX"
    SF-FONT         "Font"      "Sans"
    SF-ADJUSTMENT   "Font size" '(100 1 1000 1 10 0 1)
    SF-VALUE        "Width"     "1000"
    SF-VALUE        "Height"    "1000"
    SF-COLOR        "Color"     '(255 0 0)
    SF-GRADIENT     "Gradient"  "Deep Sea"
)
(script-fu-menu-register "script-fu-bhax-mandala" 
    "<Image>/File/Create/BHAX"
)]]></programlisting>
        </para>
        <para>
            <programlisting>(define (elem x lista)

    (if (= x 1) (car lista) (elem (- x 1) ( cdr lista ) ) )
)

(define (text-width text font fontsize)
(let*
    (
        (text-width 1)
    )
    (set! text-width (car (gimp-text-get-extents-fontname text fontsize PIXELS font)))

    text-width
    )
)

(define (text-wh text font fontsize)
(let*
    (
        (text-width 1)
        (text-height 1)
    )
    (set! text-width (car (gimp-text-get-extents-fontname text fontsize PIXELS font)))
    (set! text-height (elem 2  (gimp-text-get-extents-fontname text fontsize PIXELS font)))

    (list text-width text-height)
    )
)

(define (script-fu-bhax-mandala text text2 font fontsize width height color gradient)
(let*
    (
        (image (car (gimp-image-new width height 0)))
        (layer (car (gimp-layer-new image width height RGB-IMAGE "bg" 100 LAYER-MODE-NORMAL-LEGACY)))
        (textfs)
        (text-layer)
        (text-width (text-width text font fontsize))
        ;;;
        (text2-width (car (text-wh text2 font fontsize)))
        (text2-height (elem 2 (text-wh text2 font fontsize)))
        ;;;
        (textfs-width)
        (textfs-height)
        (gradient-layer)
    )</programlisting>
        </para>
        <para>A program ezen része felelős azért, hogy magát a fájlunkat hozzuk létre, illetve a
                <code>let</code> egy beépített kulcsszó, ezzel lehet lokális változókat létrehozni,
            az első ilyen fontos változónk az <code>image</code>, a másik a <code>layer</code>. A
                <code>car</code> azt jelenti, hogy az utána lévő lista első elemét kiveszi, még
            akkor is, ha az a lista csak egy elemű. Az elején található <code>cdr</code> pedig pont
            azért felelős, hogy az elsőn kívüli elemeket íratja ki, ha az if utasítás fejrésze
            hamis. </para>
        <para>
            <programlisting>    (gimp-image-insert-layer image layer 0 0)

    (gimp-context-set-foreground '(0 255 0))
    (gimp-drawable-fill layer FILL-FOREGROUND)
    (gimp-image-undo-disable image) 

    (gimp-context-set-foreground color)</programlisting>
        </para>
        <para>Elsőnek létrehozunk egy réteget a képnek, aztán ezt a vödör eszközzel fehér színre
            festjük be az egész réteget. Az utolsó sor pedig azért felelős, hogy a program során
            szabadon mi is kiválaszthassunk egy színt, így az lényegében felülírja a fehér színt egy
            saját, egyénileg választott színnel. </para>
        <para>
            <programlisting>    (set! textfs (car (gimp-text-layer-new image text font fontsize PIXELS)))
    (gimp-image-insert-layer image textfs 0 -1)
    (gimp-layer-set-offsets textfs (- (/ width 2) (/ text-width 2))  (/ height 2))
    (gimp-layer-resize-to-image-size textfs)

    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate-simple text-layer ROTATE-180 TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))

    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 2) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))</programlisting>
        </para>
        <para>Az első sorral adjuk meg a szövegünket, ahhoz betűtípust és méretet pixelben.
            Létrehozunk egy szövegmezőt, ahova a szövegünk fog kerülni, ennek a szélességét és
            magasságát is megfelezzük maga a kép méretéhez képest. Megduplázzuk a rétegünket és a
            másodikat megforgatjuk a szövegünket 180 fokkal, így kétszer fog szerepelni a nevünk, az
            egyik fejjel lefelé. Ezeket kell összemergelnünk, hogy egy réteggé álljanak. Az
            összemergelt fájlt is lemásoljuk és ezután 90 fokkal forgatjuk el.  </para>
        <para>
            <programlisting>    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 4) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))
    
    (set! text-layer (car (gimp-layer-new-from-drawable textfs image)))
    (gimp-image-insert-layer image text-layer 0 -1)
    (gimp-item-transform-rotate text-layer (/ *pi* 6) TRUE 0 0)
    (set! textfs (car(gimp-image-merge-down image text-layer CLIP-TO-BOTTOM-LAYER)))    
    
    (plug-in-autocrop-layer RUN-NONINTERACTIVE image textfs)
    (set! textfs-width (+ (car(gimp-drawable-width textfs)) 100))
    (set! textfs-height (+ (car(gimp-drawable-height textfs)) 100))
        
	(gimp-layer-resize-to-image-size textfs)</programlisting>
        </para>
        <para>Itt folytatjuk tovább a forgatásokat, vagyis mindig először összevonjuk az eredetit az
            elforgatott másolattal, majd az így keletkezett réteget duplázzuk meg és megint
            elforgatjuk. Itt először 45, majd 30 fokkal valósítjuk meg ezt, hogy szép eredményt
            kapjunk. A végén kijelöljük a szöveget és felnagyítjuk a réteg méretére. </para>
        <para>
            <programlisting>    (gimp-image-select-ellipse image CHANNEL-OP-REPLACE (- (- (/ width 2) (/ textfs-width 2)) 18) 
        (- (- (/ height 2) (/ textfs-height 2)) 18) (+ textfs-width 36) (+ textfs-height 36))
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)
        
    (gimp-context-set-brush-size 22)
    (gimp-edit-stroke textfs)
    
    (set! textfs-width (- textfs-width 70))
    (set! textfs-height (- textfs-height 70))
    
    (gimp-image-select-ellipse image CHANNEL-OP-REPLACE (- (- (/ width 2) (/ textfs-width 2)) 18) 
        (- (- (/ height 2) (/ textfs-height 2)) 18) (+ textfs-width 36) (+ textfs-height 36))
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)
        
    (gimp-context-set-brush-size 8)
    (gimp-edit-stroke textfs)
        
    (set! gradient-layer (car (gimp-layer-new image width height RGB-IMAGE "gradient" 100 LAYER-MODE-NORMAL-LEGACY)))
    
    (gimp-image-insert-layer image gradient-layer 0 -1)
	(gimp-image-select-item image CHANNEL-OP-REPLACE textfs)
	(gimp-context-set-gradient gradient) 
	(gimp-edit-blend gradient-layer BLEND-CUSTOM LAYER-MODE-NORMAL-LEGACY GRADIENT-RADIAL 100 0 
	REPEAT-TRIANGULAR FALSE TRUE 5 .1 TRUE (/ width 2) (/ height 2) (+ (+ (/ width 2) (/ textfs-width 2)) 8) (/ height 2))
	
	(plug-in-sel2path RUN-NONINTERACTIVE image textfs)

    (set! textfs (car (gimp-text-layer-new image text2 font fontsize PIXELS)))
    (gimp-image-insert-layer image textfs 0 -1)
    (gimp-message (number->string text2-height))
    (gimp-layer-set-offsets textfs (- (/ width 2) (/ text2-width 2)) (- (/ height 2) (/ text2-height 2)))
		
    ;(gimp-selection-none image)
    ;(gimp-image-flatten image)
    
    (gimp-display-new image)
    (gimp-image-clean-all image)
    )
)</programlisting>
        </para>
        <para>Kirajzolunk két kört, viszont mivel ezeket ellipszissel rajzoltatjuk ki, így ezeknek
            meg kell adnunk, hogy tényleg szabályos kör alakúak legyenek. Ezután az egyiknek (a
            külsőnek) 22 pixeles vastagságot állítunk be, a belsőnek pedig 8 pixelt. Az utolsó
            lépésben kiválasztjuk a gradienst, kijelöljük a képrétegünket, vagyis a neveinket és a
            két kört, és ezeken alkalmazzuk a gradienst, vagyis a színátmenetet. </para>
        <para>
            <programlisting>(script-fu-register "script-fu-bhax-mandala"
    "Mandala9"
    "Creates a mandala from a text box."
    "Norbert Bátfai"
    "Copyright 2019, Norbert Bátfai"
    "January 9, 2019"
    ""
    SF-STRING       "Text"      "Bátf41 Haxor"
    SF-STRING       "Text2"     "BHAX"
    SF-FONT         "Font"      "Sans"
    SF-ADJUSTMENT   "Font size" '(100 1 1000 1 10 0 1)
    SF-VALUE        "Width"     "1000"
    SF-VALUE        "Height"    "1000"
    SF-COLOR        "Color"     '(255 0 0)
    SF-GRADIENT     "Gradient"  "Deep Sea"
)</programlisting>
        </para>
        <para>A forráskód végén létrehozzuk az űrlapot, amit kitöltve egyszerűen létre tudjuk hozni
            a névmandalánkat. Nyilván elsőnek két sztringet adunk meg, az a két szöveget írjuk be,
            amit szeretnénk megforgatni, beépíteni a mandalánkba. Ezután meg tudjuk adni a
            betűtípust, a betűméretet, a kép méreteit (szélesség, magasság), a színt, illetve a
            gradienst. Ez utóbbit az előző feladatban már megmagyaráztuk, ez felelős a
            színátmenetért. Ezeknek az értéke a GIMP programban megváltoztatható, a forráskódban
            ezek csak alap beállításként vannak jelen. </para>
        <para>
            <figure>
                <title/>
                <mediaobject>
                    <imageobject>
                        <imagedata fileref="8csokor/nevmandala.png" scale="35"/>
                    </imageobject>
                    <textobject>
                        <phrase/>
                    </textobject>
                </mediaobject>
            </figure>
        </para>
    </section>
</chapter>                
